
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Evaluating models from reports (backup) &#8212; Battery SOH 2022 documentation</title>
    
  <link href="_static/css/theme.css" rel="stylesheet" />
  <link href="_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="_static/basic.css" />
    
  <link rel="preload" as="script" href="_static/js/index.1c5a1a01449ed65a7b51.js">

    <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
    <script src="_static/jquery.js"></script>
    <script src="_static/underscore.js"></script>
    <script src="_static/doctools.js"></script>
    <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    
    <nav class="navbar navbar-light navbar-expand-lg bg-light fixed-top bd-navbar" id="navbar-main"><div class="container-xl">

  <div id="navbar-start">
    
    

<a class="navbar-brand" href="index.html">
  <img src="_static/logo.png" class="logo" alt="logo">
</a>


    
  </div>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapsible" aria-controls="navbar-collapsible" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  
  <div id="navbar-collapsible" class="col-lg-9 collapse navbar-collapse">
    <div id="navbar-center" class="mr-auto">
      
      <div class="navbar-center-item">
        <ul id="navbar-main-elements" class="navbar-nav">
    <li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Colabs.html">
  Google Colabs
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/main.html">
  Useful dictionaries
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Battery%20Classes.html">
  Battery Classes
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Cleaning.html">
  Treatment functions
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Models.html">
  Models
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Training.html">
  Training and Simulation
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Report.html">
  Report related
 </a>
</li>

    
</ul>
      </div>
      
    </div>

    <div id="navbar-end">
      
      <div class="navbar-end-item">
        <ul id="navbar-icon-links" class="navbar-nav" aria-label="Icon Links">
      </ul>
      </div>
      
    </div>
  </div>
</div>
    </nav>
    

    <div class="container-xl">
      <div class="row">
          
            
            <!-- Only show if we have sidebars configured, else just a small margin  -->
            <div class="col-12 col-md-3 bd-sidebar"><form class="bd-search d-flex align-items-center" action="search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
  <div class="bd-toc-item active">
    
  </div>
</nav>
            </div>
            
          

          
          <div class="d-none d-xl-block col-xl-2 bd-toc">
            
              
              <div class="toc-item">
                

<nav id="bd-toc-nav">
    
</nav>
              </div>
              
              <div class="toc-item">
                
              </div>
              
            
          </div>
          

          
          
            
          
          <main class="col-12 col-md-9 col-xl-7 py-md-5 pl-md-5 pr-md-4 bd-content" role="main">
              
              <div>
                
  <div class="section" id="evaluating-models-from-reports-backup">
<h1>Evaluating models from reports (backup)<a class="headerlink" href="#evaluating-models-from-reports-backup" title="Permalink to this headline">¶</a></h1>
<p>Corresponds to the <code class="docutils literal notranslate"><span class="pre">Old_Load_Save</span></code> module</p>
<span class="target" id="module-Old_Load_Save"></span><dl class="py function">
<dt class="sig sig-object py" id="Old_Load_Save.Load_Save">
<span class="sig-prename descclassname"><span class="pre">Old_Load_Save.</span></span><span class="sig-name descname"><span class="pre">Load_Save</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">report_name</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">device</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'cpu'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">plot_bool</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">analysis</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">True</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">epoch</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">dataset_name</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'Nasa'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">report_bool</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">True</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">complete</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">denormalize_bool</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">True</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Old_Load_Save.html#Load_Save"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Old_Load_Save.Load_Save" title="Permalink to this definition">¶</a></dt>
<dd><p>This function loads the models contained in a report and simulates it’s
performance in all of the available batteries.</p>
<p>The function reaches into the report directory automatically and loads
both the best and the last epochs’ models. It also reads through the
load_info.txt file which batteries were used for training and which were
ignored. It will then evaluate the model in each battery that hasn’t been
ignored and save an image of each result in folders <cite>Images_Best</cite> (for the
best epoch) and <cite>Images_Final</cite> (for the last epoch) inside of the original
report folder (<cite>report_name</cite>).</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>report_name</strong> (<em>'string'</em>) – The name of the report directory. Is usually a date.</p></li>
<li><p><strong>device</strong> (<em>torch.device</em><em> or </em><em>str</em><em>, </em><em>default = 'cpu'</em>) – In which device the model and evaluation should be done.
Can either be ‘cpu’ or a cuda (‘cuda:0’, ‘cuda:1’, …).</p></li>
<li><p><strong>plot_bool</strong> (<em>bool</em>) – A boolean variable indicating whether or not to plot the battery
evaluations as they are done.</p></li>
<li><p><strong>analysis</strong> (<em>bool</em>) – Whether or not to run a more individual analysis of the different
batteries.</p></li>
<li><p><strong>epoch</strong> (<em>int</em><em>, </em><em>optional</em>) – The epoch number if the user wants to load the model’s parameter for
a specific epoch.</p></li>
<li><p><strong>dataset_name</strong> (<em>{'Nasa'</em><em>, </em><em>'Severson'}</em>) – A string explaining which dataset to use.</p></li>
<li><p><strong>report_bool</strong> (<em>bool</em>) – A boolean variable for controlling whether or not to create the images
for each battery prediction.</p></li>
</ul>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><ul class="simple">
<li><p><strong>NameError</strong> – When an unknown dataset_name or model_name is given.</p></li>
<li><p><strong>AttributeError</strong> – When the model does nor have attribute model_name.</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="Old_Load_Save.Load_Save_v2">
<span class="sig-prename descclassname"><span class="pre">Old_Load_Save.</span></span><span class="sig-name descname"><span class="pre">Load_Save_v2</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">report_name</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">dataset_name</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">fixed_len</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">150</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">time_step</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">analysis</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">True</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">device</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'cpu'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">norm_test</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'dataset'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">Model</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">offset_analysis</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">cycle_lim</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1000000.0</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">denormalize_bool</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">True</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Old_Load_Save.html#Load_Save_v2"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Old_Load_Save.Load_Save_v2" title="Permalink to this definition">¶</a></dt>
<dd><p>Function for running a model on different datasets.</p>
<p>The function takes a <code class="docutils literal notranslate"><span class="pre">report_name</span></code> as input, and accesses the report to
find the desired model. With <code class="docutils literal notranslate"><span class="pre">dataset_name</span></code>, it access the correct folder
for the dataset to test.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>How to proceed when a <code class="docutils literal notranslate"><span class="pre">ModuleNotFoundError</span></code> is raised:
This is caused when a model trained with an older module tries to be
loaded. The older and newer models are compatible (the only thing that
changed between modules was only the <code class="docutils literal notranslate"><span class="pre">Torch_Dataset_LSTM</span></code> function).</p>
<p>In order to make this work, you’ll have to open the <cite>TEST_Report.txt</cite>
file in the desired report folder. It will contain all of the
information needed to initialize a similar model the paramters of which
can be replaced with the ones saved in the report.</p>
<p>In the <cite>TEST_Report.txt</cite> file, you’ll find something like this:</p>
<div class="highlight-text notranslate"><div class="highlight"><pre><span></span>MODEL
  Model name: LSTM
  Version: 4
  Dataset Format: You et al. [56]
  Delta: 10
  Hidden layer dimension: 50
  Pooling_layer: bi_mean
  Dropout prob.: 0
  Number of linear layers: 1
</pre></div>
</div>
<p>Define a model of the same version:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">model</span> <span class="o">=</span> <span class="n">LSTM_v4</span><span class="p">(</span><span class="n">Delta</span><span class="p">,</span> <span class="n">Hidden</span> <span class="n">layer</span> <span class="n">dimension</span><span class="p">,</span>
                <span class="n">pooling_layer</span><span class="o">=</span><span class="n">Pooling_layer</span><span class="p">,</span> <span class="n">drop_out</span><span class="o">=</span><span class="n">Dropout</span> <span class="n">prob</span><span class="o">.</span><span class="p">,</span>
                <span class="n">version</span><span class="o">=</span><span class="n">Version</span><span class="p">,</span> <span class="n">lin_layers</span><span class="o">=</span><span class="n">Number</span> <span class="n">of</span> <span class="n">linear</span> <span class="n">layers</span><span class="p">,</span>
                <span class="n">lin_dropout</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
</pre></div>
</div>
<p>(If <code class="docutils literal notranslate"><span class="pre">lin_dropout</span> <span class="pre">&gt;</span> <span class="pre">0</span></code>, an extra entry will be present in the report).
For versions 1 through 3, call <code class="xref py py-class docutils literal notranslate"><span class="pre">LSTM_v1</span></code> instead.</p>
<p>Then, just call this function again with variable <code class="docutils literal notranslate"><span class="pre">Model=model</span></code></p>
</div>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>report_name</strong> (<em>str</em>) – The name of the report folder inside the “Reports” folder.</p></li>
<li><p><strong>dataset_name</strong> (<em>{'Nasa'</em><em>, </em><em>'Sev'</em><em>, </em><em>'Coin'}</em>) – The name of the dataset to test the model on.</p></li>
<li><p><strong>fixed_len</strong> (<em>int</em><em>, </em><em>default = 150</em>) – The final length of the resampled charge curve data (in number of
points). See <code class="docutils literal notranslate"><span class="pre">Torch_Dataset_LSTM</span></code> in <cite>LSTM.py</cite> for more information.</p></li>
<li><p><strong>time_step</strong> (<em>float</em><em>, </em><em>optional</em>) – The desired time step for the resampling procedure.
If <code class="docutils literal notranslate"><span class="pre">None</span></code> is given, than a time step will be automatically generated
in function of the given <code class="docutils literal notranslate"><span class="pre">norm_test</span></code> variable.</p></li>
<li><p><strong>analysis</strong> (<em>bool</em><em>, </em><em>default = True</em>) – Whether or not to run a quantitative analysis of the dataset.
See <code class="docutils literal notranslate"><span class="pre">Analysis</span></code> function in <cite>Load_Save</cite> for more information.</p></li>
<li><p><strong>device</strong> (<em>torch.device</em><em> or </em><em>str</em><em>, </em><em>default = 'cpu'</em>) – In which device the model and evaluation should be done.
Can either be ‘cpu’ or a cuda (‘cuda:0’, ‘cuda:1’, …).</p></li>
<li><p><strong>norm_test</strong> (<em>str</em><em> or </em><em>list</em><em>(</em><em>str</em><em>)</em>) – <p>Informs how to calculate the normalization information to be used for
the data. It can be:</p>
<blockquote>
<div><p>”Model” : the model normalization will be used
“dataset” : the whole dataset will be used
list(str) : the batteries in the list</p>
<blockquote>
<div><p>Example: [‘B0001’, ‘B0005’, ‘B0025’]
Batteries 1, 5 and 25 from the dataset will be used.</p>
</div></blockquote>
</div></blockquote>
<p>If <code class="docutils literal notranslate"><span class="pre">time_step</span></code> is <code class="docutils literal notranslate"><span class="pre">None</span></code>, then the time_step will also be calculated
automatically for these batteries.</p>
</p></li>
<li><p><strong>Model</strong> (<em>torch.nn.Module</em><em>, </em><em>optional</em>) – A model to use as a base for loading the report’s parameters. This is
only necessary when trying to load a Model trained with an older module.
Check this function’s note for more information on how this should be
initialized.</p></li>
<li><p><strong>offset_analysis</strong> (<em>bool</em><em>, </em><em>optional</em>) – Whether or not to add an offset to the model’s bias term in order to
decrease the offset error.</p></li>
<li><p><strong>cycle_lim</strong> (<em>int</em><em>, </em><em>optional</em>) – The greatest cycle number to take into account for the dataset creation.
Default equals <code class="docutils literal notranslate"><span class="pre">1e6</span></code> meaning that no cycles will be ignored.</p></li>
</ul>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><ul class="simple">
<li><p><strong>NameError</strong> – When an unknown <code class="docutils literal notranslate"><span class="pre">dataset_name</span></code>, model name or <code class="docutils literal notranslate"><span class="pre">norm_test</span></code> is given.</p></li>
<li><p><strong>ModuleNotFoundError</strong> – When an older module tries to be imported.</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="Old_Load_Save.Analysis">
<span class="sig-prename descclassname"><span class="pre">Old_Load_Save.</span></span><span class="sig-name descname"><span class="pre">Analysis</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">battery_loader_list</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">model</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">train</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">device</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'cpu'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">file_name</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">''</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">base_capacity</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">denormalize</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">True</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Old_Load_Save.html#Analysis"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Old_Load_Save.Analysis" title="Permalink to this definition">¶</a></dt>
<dd><p>Analyses the model’s performance over the different batteries.</p>
<p>Calculates the mean and maximum absolute error, mean and maximum relative
error, and the root mean squared error (RMSE).</p>
<p>A report will create a text file with the results.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>battery_loader_list</strong> (<em>list</em><em>[</em><em>torch.utils.data.DataLoader</em><em>]</em>) – The battery’s DataLoader loader.</p></li>
<li><p><strong>model</strong> (<em>torch.nn.Module</em>) – The model to use for the analysis.</p></li>
<li><p><strong>device</strong> (<em>torch.device</em><em> or </em><em>str</em><em>, </em><em>default = 'cpu'</em>) – In which device the model and evaluation should be done.
Can either be ‘cpu’ or a cuda (‘cuda:0’, ‘cuda:1’, …).</p></li>
<li><p><strong>file_name</strong> (<em>str</em>) – A string to add to the Analysis file name. The final name will be
‘Analysis’+file_name+’.txt’.</p></li>
<li><p><strong>base_capacity</strong> (<em>float</em><em>, </em><em>default = 2.1</em>) – The battery’s maximum capacity value (at its beginning of life).</p></li>
</ul>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><strong>TypeError</strong> – If the normalization type present in battery_loader.dataset.norm is not
    supported.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="Old_Load_Save.offset_calculator">
<span class="sig-prename descclassname"><span class="pre">Old_Load_Save.</span></span><span class="sig-name descname"><span class="pre">offset_calculator</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">Model</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">dataset</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">device</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'cpu'</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Old_Load_Save.html#offset_calculator"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Old_Load_Save.offset_calculator" title="Permalink to this definition">¶</a></dt>
<dd><p>Calculates the mean offset between prediction and experimental values.</p>
<p>This function will automatically update the model’s bias parameter in order
to decrease the offset.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>Model</strong> (<em>torch.nn.Module</em>) – The Model to be analyzed and updated.</p></li>
<li><p><strong>dataset</strong> (<em>torch.utils.data.Dataset</em>) – The dataset to get the offset from.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p></p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>The model with updated bias parameter.</p>
</dd>
</dl>
</dd></dl>

</div>


              </div>
              
              
              <div class='prev-next-bottom'>
                

              </div>
              
          </main>
          

      </div>
    </div>
  
  <script src="_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  <footer class="footer mt-5 mt-md-0">
  <div class="container">
    
    <div class="footer-item">
      <p class="copyright">
    &copy; Copyright 2022, Antonio ROCHA AZEVEDO.<br/>
</p>
    </div>
    
    <div class="footer-item">
      <p class="sphinx-version">
Created using <a href="http://sphinx-doc.org/">Sphinx</a> 4.0.2.<br/>
</p>
    </div>
    
  </div>
</footer>
  </body>
</html>